{
  Crystal Design Component Demo Application 2:

  Copyright (c) 1997, SupraSoft Ltd

  Purpose of this program is to demonstrate
  - Use of parameter fields (TCDCParameterFieldInfo)
  - Use of selection formula (SetSelectionFormula)
  - Use of formula (SetFormula)
}
unit Demo2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,
  Crystdsg, CrystDef;

type
  TForm1 = class(TForm)
    CrystalDesign1: TCrystalDesign;
    Panel1: TPanel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Button1: TButton;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CrystalDesign1Error(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.CrystalDesign1Error(Sender: TObject);
begin
  Caption := CrystalDesign1.LastErrorText;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  exePath: string;
begin
  exePath := ExtractFilePath(Application.ExeName);

  { Report file AND database file are in the same place }
  { with the exectuable file.                           }
  CrystalDesign1.ReportLocation := exePath;
  CrystalDesign1.CommonTableLocations := exePath;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  text:     string;
  cdcField: TCDCParameterFieldInfo;
begin
  CrystalDesign1.Active := FALSE;

  { Set the value of a parameter field }
  cdcField := CrystalDesign1.GetNthCDCParameterField(0);
  if cdcField <> nil then begin
     { Set current value of a parameter field programmatically    }
     { using string type. There are also ex. AsInteger, AsDate    }
     { and AsDouble properties. When the component is activated,  }
     { the standard parameter field input dialogbox is NOT shown. }
     cdcField.CurrentValue.AsString := ComboBox1.Text;

     { Send parameter field values to a report and free object }
     cdcField.SetField;
     cdcField.Free;
  end;

  { Set selection formula value based on a month filter }
  text := '';
  if ComboBox2.ItemIndex > 0 then
     text := 'Month({customer.ContactDat}) = ' + IntToStr(ComboBox2.ItemIndex);
  CrystalDesign1.SetSelectionFormula(text);

  { Set a content of a "Caption" formula to show month filter value }
  text := '{?City} + " Office ' + ComboBox2.Text + '"';
  CrystalDesign1.SetFormula('Caption', text);

  { Re-activate the component }
  CrystalDesign1.Active := TRUE;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  { Toggle between three standard zoom factors }
  CrystalDesign1.NextPrintWindowMagnification;
end;

end.
